<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch">
      <el-form-item label="用户编号" prop="userNumber">
        <el-input
          v-model="queryParams.userNumber"
          placeholder="请输入用户编号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="设备编号" prop="deviceNumber">
        <el-input
          v-model="queryParams.deviceNumber"
          placeholder="请输入设备编号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['deviceRelation:relation:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['deviceRelation:relation:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['deviceRelation:relation:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['deviceRelation:relation:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="relationList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="关系id" align="center" prop="relationId" v-if="false"/>
      <el-table-column label="用户编号" align="center" prop="userNumber" />
      <el-table-column label="设备编号" align="center" prop="deviceNumber" />
      <el-table-column label="有效日期" align="center" prop="effectTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.effectTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="机构" align="center" prop="jgid" v-if="false"/>
      <el-table-column label="是否删除" align="center" prop="isDelete" v-if="false"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['deviceRelation:relation:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['deviceRelation:relation:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改设备绑定1对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" >
        <el-form-item label="用户编号" prop="userNumber">
          <el-select v-model="form.userNumber" placeholder="请选择用户" filterable>
            <el-option
              v-for="item in userList"
              :key="item.userName"
              :label="item.nickName"
              :value="item.userName"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="设备编号" prop="deviceNumber">
          <el-select v-model="form.deviceNumber" placeholder="请选择设备" filterable>
            <el-option
              v-for="item in deviceList"
              :key="item.deviceNo"
              :label="item.deviceName"
              :value="item.deviceNo"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="有效时间" prop="effectTime">
          <el-date-picker clearable size="small"
            v-model="form.effectTime"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择有效时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="机构代码" prop="jgid" v-if="false">
          <el-input v-model="form.jgid" placeholder="请输入机构代码" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listRelation, getRelation, delRelation, addRelation, updateRelation, exportRelation } from "@/api/system/relation";
import user from "@/store/modules/user";
import {listDevice } from "@/api/device/device";
import {getUserOrganization } from "@/api/system/user";

export default {
  name: "deviceRelation",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 设备绑定1表格数据
      relationList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userNumber: null,
        deviceNumber: null,
        jgid:null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        userNumber: [
          { required: true, message: "用户编号不能为空", trigger: "blur" }
        ],
        deviceNumber: [
          { required: true, message: "设备编号不能为空", trigger: "blur" }
        ],
      },
      deviceList: [],
      userList:[],
    };
  },
  created() {
    this.getList();
    this.getDeviceList();
    this.getUserList();
  },
  methods: {
    /** 查询设备绑定1列表 */
    getList() {
      this.loading = true;
      this.queryParams.jgid = user.state.organ;
      listRelation(this.queryParams).then(response => {
        this.relationList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    getDeviceList(){
      listDevice({deviceOrgId: user.state.organ}).then(response =>{
        this.deviceList = response.rows;
      })
    },
    getUserList(){
      getUserOrganization({organizationCode: user.state.organ}).then(response =>{
        this.userList = response.data;
      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        relationId: null,
        userNumber: null,
        deviceNumber: null,
        effectTime: null,
        jgid: null,
        isDelete: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.relationId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加设备绑定1";
      this.form.jgid = user.state.organ;
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const relationId = row.relationId || this.ids
      getRelation(relationId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改设备绑定1";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.relationId != null) {
            updateRelation(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRelation(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const relationIds = row.relationId || this.ids;
      this.$modal.confirm('是否确认删除设备绑定1编号为"' + relationIds + '"的数据项？').then(function() {
        return delRelation(relationIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$modal.confirm('是否确认导出所有设备绑定1数据项？').then(() => {
        this.exportLoading = true;
        return exportRelation(queryParams);
      }).then(response => {
        this.$download.name(response.msg);
        this.exportLoading = false;
      }).catch(() => {});
    }
  }
};
</script>
